package me.paradoxpixel.themepark.placeholder;

import me.clip.placeholderapi.expansion.PlaceholderExpansion;
import me.paradoxpixel.themepark.api.API;
import me.paradoxpixel.themepark.api.attraction.component.Status;
import me.paradoxpixel.themepark.attraction.status.StatusManager;
import me.paradoxpixel.themepark.utils.Utils;
import org.bukkit.OfflinePlayer;
import org.bukkit.plugin.Plugin;

public class ThemeParkPlaceholder extends PlaceholderExpansion {

    private Plugin plugin;

    public ThemeParkPlaceholder(Plugin plugin){
        this.plugin = plugin;
    }

    @Override
    public boolean persist(){
        return true;
    }

    @Override
    public boolean canRegister() {
        return true;
    }

    @Override
    public String getAuthor() {
        return "ParadoxPixel";
    }

    @Override
    public String getIdentifier() {
        return "tp";
    }

    @Override
    public String getVersion() {
        return plugin.getDescription().getVersion();
    }

    @Override
    public String onRequest(OfflinePlayer player, String identifier){
       if(identifier == null || player == null)
           return "";

       if(identifier.startsWith("status")) {
           String[] args = identifier.split(":");
           if(args.length < 2)
               return "";

           String id = args[1];
           if(!API.isAttraction(id))
               return "";

           Status status = API.getAttraction(id).getStatus();
           return Utils.color(StatusManager.getName(status));
       }

        if(identifier.startsWith("name")) {
            String[] args = identifier.split(":");
            if(args.length < 2)
                return "";

            String id = args[1];
            if(!API.isAttraction(id))
                return "";

            String name = API.getAttraction(id).getName();
            return Utils.color(name);
        }

        return "";
    }

}